//+---------------------------------------------------------------------+
//|                                                   Mass_Index_BB.mq5 | 
//|                                Copyright  2011,   Nikolay Kositsin | 
//|                                 Khabarovsk,   farria@mail.redcom.ru | 
//+---------------------------------------------------------------------+
//|          SmoothAlgorithms.mqh |
//|   (): terminal_data_folder\MQL5\Include             |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "Mass Index"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 9 
//----    
#property indicator_plots   7
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//----      
#property indicator_type1   DRAW_COLOR_HISTOGRAM
//----     
#property indicator_color1 Gray,Green,Magenta
//----   -  
#property indicator_style1  STYLE_SOLID
//----     3
#property indicator_width1  3
//----   
#property indicator_label1  "Mass Index"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//----      
#property indicator_type2   DRAW_COLOR_LINE
//----      
#property indicator_color2 Gray,Blue,DarkOrange
//----   - 
#property indicator_style2  STYLE_DASH
//----     2
#property indicator_width2  2
//----   
#property indicator_label2  "Signal line"
//+--------------------------------------------+
//|     BB  |
//+--------------------------------------------+
//----      
#property indicator_type3   DRAW_LINE
#property indicator_type4   DRAW_LINE
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE
#property indicator_type7   DRAW_LINE
//----    
#property indicator_color3  Blue
#property indicator_color4  Red
#property indicator_color5  Gray
#property indicator_color6  Red
#property indicator_color7  Blue
//----   -  
#property indicator_style3 STYLE_DASHDOTDOT
#property indicator_style4 STYLE_DASHDOTDOT
#property indicator_style5 STYLE_DASHDOTDOT
#property indicator_style6 STYLE_DASHDOTDOT
#property indicator_style7 STYLE_DASHDOTDOT
//----     1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
//----    
#property indicator_label3  "+2Sigma"
#property indicator_label4  "+Sigma"
#property indicator_label5  "Middle"
#property indicator_label6  "-Sigma"
#property indicator_label7  "-2Sigma"
//+-------------------------------------------+
//|      |
//+-------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+-----------------------------------+
//----    CXMA  CStdDeviation   SmoothAlgorithms.mqh
CXMA XMA1,XMA2,XMA3,SUM,SIGN;
CStdDeviation STD;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPLE_,        // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
enum IndStyle //  
  {
   COLOR_LINE = DRAW_COLOR_LINE,          //  
   COLOR_HISTOGRAM=DRAW_COLOR_HISTOGRAM,  //  
   COLOR_ARROW=DRAW_COLOR_ARROW           //  
  };
/*enum Smooth_Method -    SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int APeriod=25;                       //  
input Smooth_Method DSmoothMethod=MODE_EMA; //   
input int DPeriod=9;                        //   
input int DPhase=100;                       //   
input Smooth_Method SSmoothMethod=MODE_EMA; //    
input int SPeriod=7;                        //   
input int SPhase=100;                       //   
input int Shift=0;                          //      
input IndStyle Style=COLOR_HISTOGRAM;       //   MI
input int BBPeriod=100;                     //    
input double BBDeviation1 = 1.0;            //  
input double BBDeviation2 = 1.6;            //  
//+-----------------------------------+
//----   ,    
//----      
double MIBuffer[],XMIBuffer[];
double ColorMIBuffer[],ColorXMIBuffer[];
double ExtLineBuffer1[],ExtLineBuffer2[],ExtLineBuffer3[],ExtLineBuffer4[],ExtLineBuffer5[];
//----     
double quotient;
//----      
int StartBars,StartBarsA,StartBarsD,StartBarsD2,StartBarsS,StartBarsB;
//+------------------------------------------------------------------+   
//| Mass Index indicator initialization function                     | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   StartBarsD=XMA1.GetStartBars(DSmoothMethod,DPeriod,DPhase);
   StartBarsA=2*StartBarsD+1+APeriod;
   StartBarsD2=2*StartBarsD+1;
   StartBarsS=StartBarsD2+XMA1.GetStartBars(SSmoothMethod,SPeriod,SPhase);
   StartBarsB=StartBarsD+BBPeriod;
   StartBars=MathMax(StartBarsS,StartBarsB);
//----       
   XMA1.XMALengthCheck("DPeriod", DPeriod);
   XMA1.XMALengthCheck("SPeriod", SPeriod);
//----       
   XMA1.XMAPhaseCheck("DPhase",DPhase,DSmoothMethod);
   XMA1.XMAPhaseCheck("SPhase",SPhase,SSmoothMethod);
//----     
   quotient=BBDeviation2/BBDeviation1;

//----    MIBuffer[]   
   SetIndexBuffer(0,MIBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,StartBarsA+1);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,Style);

//----    ColorMIBuffer[]  ,     
   SetIndexBuffer(1,ColorMIBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,StartBarsA+1);

//----    XMIBuffer[]   
   SetIndexBuffer(2,XMIBuffer,INDICATOR_DATA);
//----    2  
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,StartBarsA+1);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    ColorXMIBuffer[]  ,     
   SetIndexBuffer(3,ColorXMIBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,StartBars+1);

//----      
   SetIndexBuffer(4,ExtLineBuffer1,INDICATOR_DATA);
   SetIndexBuffer(5,ExtLineBuffer2,INDICATOR_DATA);
   SetIndexBuffer(6,ExtLineBuffer3,INDICATOR_DATA);
   SetIndexBuffer(7,ExtLineBuffer4,INDICATOR_DATA);
   SetIndexBuffer(8,ExtLineBuffer5,INDICATOR_DATA);
//----  ,      
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,StartBars);
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,StartBars);
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,StartBars);
   PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,StartBars);
   PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,StartBars);
//----      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(6,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(7,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(8,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----      
   string shortname,Smooth;
   Smooth=XMA1.GetString_MA_Method(DSmoothMethod);
   StringConcatenate(shortname,"Mass Index(",string(DPeriod),",",Smooth,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+ 
//| Mass Index iteration function                                    | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<StartBars) return(0);
//----       
   double dprice_,x1xma,x2xma,sum,mi,xmi,bbxma,stdev1,stdev2;
//----        
   int first1,first2,first3,bar;
//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first1=0; //      
      first2=StartBarsD+1;
      first3=StartBarsS+1;
     }
   else
     {
      first1=prev_calculated-1; //      
      first2=first1;
      first3=first1;
     }
//----    
   for(bar=first1; bar<rates_total; bar++)
     {
      //----   PriceSeries      dprice_
      dprice_=high[bar]-low[bar];
      //----    XMASeries.  
      x1xma=XMA1.XMASeries(0,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,dprice_,bar,false);
      sum=SUM.XMASeries(StartBarsD,prev_calculated,rates_total,MODE_SMA_,0,APeriod,x1xma,bar,false)*APeriod;
      x2xma=XMA2.XMASeries(StartBarsD,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,x1xma,bar,false);
      //----       
      if(x2xma==0 || x2xma==EMPTY_VALUE) mi=EMPTY_VALUE;
      else                               mi=sum/x2xma;
      //----      
      MIBuffer[bar]=mi;
      //----   
      xmi=SIGN.XMASeries(StartBarsA,prev_calculated,rates_total,SSmoothMethod,SPhase,SPeriod,mi,bar,false);
      //----      
      MIBuffer[bar]=mi;
      XMIBuffer[bar]=xmi;
      //----    
      bbxma=XMA3.XMASeries(StartBarsA,prev_calculated,rates_total,MODE_SMA_,0,BBPeriod,mi,bar,false);
      stdev1=STD.StdDevSeries(StartBarsA,prev_calculated,rates_total,BBPeriod,BBDeviation1,xmi,bbxma,bar,false);
      stdev2=stdev1*quotient;
      //---- 
      if(bar<=StartBarsB+BBPeriod)
        {
         bbxma=EMPTY_VALUE;
         stdev1=0.0;
         stdev2=0.0;
        }

      ExtLineBuffer1[bar]=bbxma+stdev2;
      ExtLineBuffer2[bar]=bbxma+stdev1;
      ExtLineBuffer3[bar]=bbxma;
      ExtLineBuffer4[bar]=bbxma-stdev1;
      ExtLineBuffer5[bar]=bbxma-stdev2;
     }
//----     
   for(bar=first3; bar<rates_total; bar++)
     {

     }
//----    
   for(bar=first2; bar<rates_total; bar++)
     {
      ColorMIBuffer[bar]=0;

      if(MIBuffer[bar]>0)
        {
         if(MIBuffer[bar]>MIBuffer[bar-1]) ColorMIBuffer[bar]=1;
         if(MIBuffer[bar]<MIBuffer[bar-1]) ColorMIBuffer[bar]=2;
        }
     }
//----     
   for(bar=first3; bar<rates_total; bar++)
     {
      ColorXMIBuffer[bar]=0;
      if(MIBuffer[bar]>XMIBuffer[bar-1]) ColorXMIBuffer[bar]=1;
      if(MIBuffer[bar]<XMIBuffer[bar-1]) ColorXMIBuffer[bar]=2;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+